/***************************************************************************
 *
 * Copyright (c) 1995 Promise Technology, Inc.  All rights reserved.
 * No part of this document may be reproduced or transmitted in any form or
 * by any means, electronic or mechanical, for any purpose, without the
 * express written permission of Promise Technology, Inc.
 *
 *
 * global.h - declarations for global variables
 *
 ***************************************************************************/

#define   DBB(x)             //debug PBM
#define   DBE(x)           //debug engine

extern WORD  V_To_P_Offset;                     /* 4 bytes */
extern WORD  P_To_V_Offset;                     /* 4 */
extern WORD  wFreePhyPoolSize;                  /* 4 */
extern WORD  wFreeVirPoolSize;                  /* 4 */
extern WORD  wPhysicalBufferAddress;            /* 4 */
extern WORD  wFreePoolSize;
extern bpBUF p_bPhyBufferAddress;               /* 2or4 */
extern bpBUF p_bVirBufferAddress;               /* 2or4 */

extern WORD wFreeAccessablePoolSize;
extern WORD wFreeInaccessablePoolSize[2];
//extern WORD wFreeInaccessablePoolSize1;    //added by isaac for dualcard
extern WORD wFreePBMAccessablePoolSize;
extern WORD wFreeNonPagePoolSize;
extern WORD wInitInaccessableMemSize[2];
//extern WORD wInitInaccessableMemSize1;    //added by isaac for dualcard
extern WORD wInitAccessableMemSize;
extern WORD wInitPBMAccessableMemSize;
extern WORD wInitNonPageMemSize;
extern WORD wInaccessableBufferAddress[2];
//extern WORD wInaccessableBufferAddress1;  //added by isaac for dualcard
extern bpBUF pPBMBufferAddress;
extern bpBUF p_bAccessableBufferAddress;
extern bpBUF pNonPageBufferAddress;      

extern bpQ   p_QueueHead[MAX_QUEUE_SUPPORTED];  /* 2or4 * 25 */
#ifndef NVM
extern bpQ   p_QueueNVMHead[MAX_RAID5_QUEUE_SUPPORTED];
extern U8 NVMBuffer[4096];
#endif

extern BoOL  blDiskFlag[MAX_CHANNEL_SUPPORTED][MAX_ID_PER_CHANNEL]; /* 16*2 */
extern WORD  wCurrentLBA[MAX_CHANNEL_SUPPORTED][MAX_ID_PER_CHANNEL]; /* 16*2*4 */
extern ByTE  bQueueCount[MAX_CHANNEL_SUPPORTED]; /* 16*1*/
extern ARY   aryDef[ACTUAL_ARRAY_SUPPORTED];    /* 64*4 */
extern ARY   aryDef1[ACTUAL_ARRAY_SUPPORTED];
extern BLOCK blkDisk[MAX_CHANNEL_SUPPORTED*MAX_ID_PER_CHANNEL]; /* 24*16*2 */
extern bpEVENT p_evMaintenanceEvent[ACTUAL_ARRAY_SUPPORTED]; /* 2or4 * 4 */
extern ByTE  ReadWriteReg[MAX_CHANNEL_SUPPORTED];

extern pENCLOSURE pEnclosure;
extern BoOL  bResetController;                   /* 05/13/97 */
extern bpDTASK p_tkPool;                        /* 2or4 */
extern bpDTASK p_Task;
extern bpEVENT p_evFirstEvent;                  /* 2or4 */
extern bpLUN p_lunDef;                          /* 2or4 */

/* Added by crimson. 10/23, Y2001*/
extern bpLUN p_lunDef1;                          /* 2or4 */

extern HALF  hTicksTillEvent;                   /* 2 */
extern ByTE  bLUN;                              /* 1 */
extern ByTE  bBlk;                              /* 1 */
extern ByTE  blChoresToDo;                      /* 1 */
extern ByTE  bEngineTask;                       /* 1 */
extern ByTE  blMyMomSaidI_AmOldEnoughFor;       /* 1 */
extern BoOL  blBackgroundMaintenance;           /* 1 */
extern BoOL  blConfigDoneFlag;                  /* 1 */
extern BoOL g_ConfigDone;
extern BoOL  g_UpdateConfigReady ;        
extern BoOL  blFlag;                            /* 1 */
   
extern WORD  wSecTick;                          /* 4 */
extern HALF  hSubmitCount;                      /* 2 */
extern BoOL  bErrorRecover;                     /* 10/26/97 Q.W */
extern ByTE  bErrorCh;                          /* 10/26/97 Q.W */
extern BoOL  bInitCH;                           /*11/20/97  Q.W  used for Hot_PLUG*/
extern BoOL  blRecovery;                        /*11/25/97  Q.W  used for HoT_Plug */
extern BoOL  bRAID;                             /*02/17/98  Q.W   */
extern BoOL  ReleaseResource;                     /*02/17/98  Q.W   */
extern BoOL  CheckInteg;                        /* 02/17/98   Q.W   */        
extern BoOL  Rebuild;
extern BoOL  Abort_Rebuild;
extern bpEVENT p_evTimedout;
extern BoOL  blDown[ACTUAL_ARRAY_SUPPORTED];                         /* 04/24/98  Q.W */
extern BoOL AnotherChNoStartBusMaster1;
extern BoOL AnotherChNoStartBusMaster2;
extern ByTE NoSubmitBusMasterCh1;
extern ByTE NoSubmitBusMasterCh2;
extern ByTE FastTrakController;
extern BoOL bConflict;
extern BoOL TwoDriveInOneChannel;
extern BoOL  blOneChannel_Busy;
extern ByTE  bOneChannelCount;
extern ByTE  bOriginalChannelCount;
extern ByTE  bChannelCountThre;  
extern BoOL  bClear;
extern bpEVENT p_TempEvent; 
extern BoOL  FirstReset;
extern BoOL  Stripe_Mirror;
extern BoOL  EventTask;
extern bpDTASK  pAnotherDiskTask;
extern bpDTASK pDiskTaskPool[16];
extern HALF RebuildLoopCount;
extern HALF RebuildRate;
extern HALF SyncRate;
extern HALF SyncLoopCount;
extern HALF Conv_Expan_Rate;
extern HALF ConvExpLoopCount;
extern HALF ConvExpanRate;


extern ByTE DisableHotSpare;
extern ByTE HotSwap; 
extern BoOL PutReqToQueue;
extern BoOL bLEDStatus[MAX_CHANNEL_SUPPORTED][MAX_ID_PER_CHANNEL];    //modified by isaac for dualcard
extern ByTE bLEDColor[MAX_CHANNEL_SUPPORTED][MAX_ID_PER_CHANNEL];
extern ByTE Sns[16];
extern BoOL setDiskStatus;
extern WORD CurrentLogEventNum;
extern WORD StartEventQueueNum;
extern ByTE SyncronizeNotCopy;
extern WORD EventErrorLBA[ACTUAL_ARRAY_SUPPORTED];
extern WORD CompareErrorLBA[ACTUAL_ARRAY_SUPPORTED];
extern ByTE Break_ECC;
extern HALF hEccErrorNonRebuild;
extern HALF hTempEccErrorNonRebuild;
extern BoOL FirstCheckRebuild;
extern ByTE Access_OneSector[ACTUAL_ARRAY_SUPPORTED];
extern WORD wBlockEndLBA[ACTUAL_ARRAY_SUPPORTED];
extern ByTE SyncEccError;
extern ByTE SyncErrorDiskID;
extern ByTE FirstLBACompError;
extern WORD SyncCompErrorNum;
extern ByTE SmartStatus[MAX_CHANNEL_SUPPORTED][MAX_ID_PER_CHANNEL];
extern ByTE PreviousSmartStatus[MAX_CHANNEL_SUPPORTED][MAX_ID_PER_CHANNEL];
extern BoOL SkipSyncEccError;
extern ByTE SyncFixEccErrorSourceID;
extern WORD PreviousCompError;
extern ByTE EnableCheckSmartStatus;
extern ByTE SmartCommandTimer;
extern ByTE AbortCount;
extern BoOL SourceDriveFail[ACTUAL_ARRAY_SUPPORTED];
extern ByTE hEccErrorRebuild;
extern BoOL RebuildAbort[MAX_BLOCK_PER_CARD]; //modified by isaac for bug
extern WORD PreviousLBA;
extern WORD PreviousCount;
extern WORD g_maintenancePolicy;
extern WORD g_syncErrorFlag;

extern U8 blSynchronizeRAID5;

extern int submitChannelCount;

#ifdef Netware
  extern ByTE    bDisplayBuffer[200];
#endif

#ifdef NT
  extern WORD wBoundary;
  extern WORD wNonBoundary;
  extern WORD wConsolidate;
#endif


#define sata_deviceid_read(adapter, deviceid)	sata_enclosure_read_byte((deviceid << 5),adapter )

#define sata_connect_second_bus(adapter, deviceid) sata_enclosure_control_simple(adapter,(deviceid << 5) | 2)

#define sata_disconnect_second_bus(adapter, deviceid) sata_enclosure_control_simple(adapter,(deviceid << 5) |4)

#define sata_rled_write(adapter, deviceid) sata_enclosure_control_simple(adapter,(deviceid << 5) | 6)

#define sata_gled_write(adapter,deviceid) sata_enclosure_control_simple(adapter,(deviceid << 5) | 8)

#define sata_oled_write(adapter,deviceid) sata_enclosure_control_simple(adapter,(deviceid << 5) | 0xa)

#define sata_yled_on_write(adapter, deviceid) sata_enclosure_control_simple(adapter,(deviceid << 5) | 0xc)

#define sata_yled_off_write(adapter, deviceid) sata_enclosure_control_simple(adapter,(deviceid << 5) | 0xe)

#define sata_chip_control_write(adapter, deviceid, controlbyte) sata_enclosure_write_byte((deviceid << 5) | 0x12,adapter, controlbyte)

#define sata_chip_control_read(adapter, deviceid) sata_enclosure_read_byte((deviceid << 5) | 0x12,adapter)

#define sata_pwm_offset_write(adapter, deviceid) sata_enclosure_write_byte((deviceid << 5) | 0x14,adapter, 5)

#define sata_global_led_write(adapter, deviceid) sata_enclosure_write_byte((deviceid << 5) | 0x16,adapter, 0x10)

#define sata_oled_off_write( adapter,  deviceid) sata_enclosure_control_simple(adapter,(deviceid << 5) | 0x18)

/***************************************************************************
 *
 *
 *
 ***************************************************************************/

#ifdef MSCOMP
extern ByTE __based(__segname("_CODE")) bEnginerVer[];
#else
extern ByTE const app_space bEngineVer[];
#endif
  
    
/*
 * notifications
 */    
#define FN_HOTPLUG                      (0)


/*ADDED by ganqh*/
#define HARDWARE_XOR 1
/*#define _INVERT_ 1*/

/* 
	Added by crimson. 11/22, Y2001 
	For 2 stage enclosure inquiry	
*/
//modified by isaac for dualcard
extern ByTE blSwapBoxCmdDone[MAX_CHANNEL_SUPPORTED][MAX_ID_PER_CHANNEL];
extern ByTE blSwapBoxCmdAccept[MAX_CHANNEL_SUPPORTED][MAX_ID_PER_CHANNEL];
extern ByTE bEnclosureCmdAccept[MAX_CHANNEL_SUPPORTED][MAX_ID_PER_CHANNEL];
extern ByTE bPowerStatus[MAX_CHANNEL_SUPPORTED][MAX_ID_PER_CHANNEL];	
extern HALF hSubmitReqCount;

//added by isaac for identify card number
//#define FINDGOODSTRM(p_lun)(
//   ByTE i;
//   for(i=0; i<p_lun->bWidth; i++) 
//   {
//     if(p_lun->strm[i].blFlag == (blVALID_BLK+blWORKING_BLK+blASSIGNED_BLK))
//    return i;
//     }  
//:)
extern ByTE FindGoodStrm(bpLUN p_lun);
extern ByTE ARRAYID2CARD(ByTE array_id);
extern ByTE PARRAY2ID( dpARY p_ary);
//#define ARRAYID2CARD( Array_ID ) ( blkDisk[aryDef[Array_ID].strm[0].bIndex].bCh < 4 ? 0:1)
