/*#define _FUJITSU*/
//#define _NEC
/*#define _DELL*/
/*#define _HITACHI*/

#if defined(_FUJITSU)
#define MAINTENANCE_LENGTH_DEFAULT 0
#define WRITEBACK_CACHE_DEFAULT    0
#define DISABLE_HOTSPARE_DEFAULT 1
#define ENABLE_SMART_CHECK 1
#define LOCALIZE           0
#define START_AS_HIDE      0
#define TOPMOST            0
#define ENABLEAUDIOPROMPT  1
#define MESSAGEBOX         1
#define ABORTFIXIGNORE     0
#define ABORTFIXIGNORESCH  0
#define SCHEDULE_DISABLE 1
#define SCHEDULE_TYPE  0
#define OEMBUILD
#endif

#if defined(_NEC)
#define MAINTENANCE_LENGTH_DEFAULT 4
#define SYNCHRONIZE_LENGTH_DEFAULT 8
#define WRITEBACK_CACHE_DEFAULT    1
#define DISABLE_HOTSPARE_DEFAULT 0
#define ENABLE_SMART_CHECK 1
#define LOCALIZE           1
#define START_AS_HIDE      0
#define TOPMOST            0
#define ENABLEAUDIOPROMPT  1
#define MESSAGEBOX         1
#define ABORTFIXIGNORE     0
#define ABORTFIXIGNORESCH  0
#define SCHEDULE_DISABLE 1
#define SCHEDULE_TYPE  0
#define OEMBUILD
#endif

#if defined(_DELL)
#define MAINTENANCE_LENGTH_DEFAULT 4
#define WRITEBACK_CACHE_DEFAULT    1
#define DISABLE_HOTSPARE_DEFAULT 0
#define ENABLE_SMART_CHECK 1
#define LOCALIZE           1
#define START_AS_HIDE      1
#define TOPMOST            1
#define ENABLEAUDIOPROMPT  1
#define MESSAGEBOX         1
#define ABORTFIXIGNORE     0
#define ABORTFIXIGNORESCH  0
#define SCHEDULE_DISABLE 1
#define SCHEDULE_TYPE  0
#define OEMBUILD
#endif

#if defined(_HITACHI)
#define MAINTENANCE_LENGTH_DEFAULT 4
#define WRITEBACK_CACHE_DEFAULT    1
#define DISABLE_HOTSPARE_DEFAULT 1
#define ENABLE_SMART_CHECK 0
#define LOCALIZE           1
#define START_AS_HIDE      1
#define TOPMOST            0
#define ENABLEAUDIOPROMPT  0
#define MESSAGEBOX         0
#define ABORTFIXIGNORE     1
#define ABORTFIXIGNORESCH  0
#define SCHEDULE_DISABLE 0
#define SCHEDULE_TYPE  1
#define OEMBUILD
#endif

//Label_bp begin
#if defined(_HPQ)
//#define BIOS_HALT_ON_ERROR		1
#define BUZZER_DEFAULT			0
#define BUF_WRITE_MODE_DEFAULT 0
#define ENABLE_HOTSWAP_DEFAULT 1
#define MAINTENANCE_LENGTH_DEFAULT 4
#define SYNCHRONIZE_LENGTH_DEFAULT 4
#define WRITEBACK_CACHE_DEFAULT    1
#define DISABLE_AUTOREBUILD_DEFAULT 0
#define DISABLE_HOTSPARE_DEFAULT 0
#define ENABLE_SMART_CHECK 1
#define LOCALIZE           1
#define START_AS_HIDE      1
#define TOPMOST            0
#define ENABLEAUDIOPROMPT  1
#define MESSAGEBOX         1
#define ABORTFIXIGNORE     0
#define ABORTFIXIGNORESCH  0
#define SCHEDULE_DISABLE 1
#define SCHEDULE_TYPE  0
#define HPQ_BACKPLANE 	1
#define OEMBUILD
#endif
//Label_bp end

/* all other OEMS, and Promise versions*/

#ifndef OEMBUILD
#ifndef _PROMISE
#define _PROMISE
#endif
#endif

#if defined(_PROMISE)
#define MAINTENANCE_LENGTH_DEFAULT 4
#define SYNCHRONIZE_LENGTH_DEFAULT 4
#define WRITEBACK_CACHE_DEFAULT    1
#define DISABLE_HOTSPARE_DEFAULT 0
#define ENABLE_SMART_CHECK 1
#define LOCALIZE           1
#define START_AS_HIDE      1
#define TOPMOST            0
#define ENABLEAUDIOPROMPT  1
#define MESSAGEBOX         1
#define ABORTFIXIGNORE     0
#define ABORTFIXIGNORESCH  0
#define SCHEDULE_DISABLE 1
#define SCHEDULE_TYPE  0
#endif
