

#ifdef __LINUX__

#define DbgBreakPoint
#ifndef UCHAR
#define PVOID   void*
#define UCHAR   unsigned char
#define USHORT  unsigned short
#define SHORT   short
#define ULONG   unsigned long
#endif

#ifndef PUCHAR
#define PUCHAR 	unsigned char*
#define PULONG  unsigned long*
#endif

#ifndef U8
#define U8 	unsigned char
#define U16 	unsigned short 
#define U32   unsigned long
#define PU8  unsigned char*
#define PU32  unsigned long*
#endif
/*
#ifndef BOOLEAN
#define BOOLEAN int
#endif*/
#ifndef TRUE
#define TRUE  1
#define FALSE 0 
#endif
#endif

#ifndef _INVERT_ 
/*#define _INVERT_ 1*/
#endif

#ifndef _MMMAP_
/*#define _MMMAP_    1*/
#endif

#ifndef _DOWNSPEED_
/*#define _DOWNSPEED_    */
#endif  /*by fanru*/

#ifndef _SUPPORT48BIT_
#define _SUPPORT48BIT_    
#endif  /*by fanru*/

#ifndef _SUPPORTENCLOSURE_
#define _SUPPORTENCLOSURE_   
#endif   /*by fanru*/



/* by Jeff */
#define INDEX_REGISTER_OFFSET   0x08
#define DATA_REGISTER_OFFSET    0x0C


#define MAX_ADAPTER_NUM 			2
#define MAXREGCNT					0x34	/* &&&&&&&&&7 */
//Label_bp begin
#define ATA_MODULE_NUM_ON_CARD    4
//Label_bp end


#define 	STATUS_FINE					1
#define 	STATUS_BAD					0


#define 	MAX_ATA_QUEUE_DEPTH				32 /*== it was 8		*/


#define HDMA_MODULE_TYPE					36

#define U32NULL							0xFFFFFFFF
#define U16NULL							0xFFFF
#define U8NULL							0xFF

#define ZERO_NULL						0x0

#define IDE_COMMAND_READ                    0x20
#define IDE_COMMAND_WRITE                   0x30

#define XOR_COMMAND_XOR						0x01
#define XOR_COMMAND_COMPARE					0x0

#define ATRLREG_REG_SIZE_8                  (0x00)
#define ATRLREG_REG_SIZE_7                  (0x07 << 5)
#define ATRLREG_REG_SIZE_6                  (0x06 << 5)
#define ATRLREG_REG_SIZE_5                  (0x05 << 5)
#define ATRLREG_REG_SIZE_4                  (0x04 << 5)
#define ATRLREG_REG_SIZE_3                  (0x03 << 5)
#define ATRLREG_REG_SIZE_2                  (0x02 << 5)
#define ATRLREG_REG_SIZE_1                  (0x01 << 5)

#define ATRLREG_CONDITION_NO                0x00
#define ATRLREG_CONDITION_CHECK_NOT_BUSY    0x10
#define ATRLREG_CONDITION_CHECK_DRDY        0x18
#define ATRLREG_CONDITION_X_DEFINE          0x08

#define ATRLREG_X_3F6                       0x0E
#define ATRLREG_X_END_1F7                   0x0F
#define ATRLREG_X_END_1F0                   0x08
#define ATRLREG_X_END_1FX                   0x08

#define ATRLREG_DATA                        0x00
#define ATRLREG_FEATURE                     0x01
#define ATRLREG_SECTOR_COUNT                0x02
#define ATRLREG_LBA0_7                      0x03
#define ATRLREG_LBA8_15                     0x04
#define ATRLREG_LBA16_23                    0x05
#define ATRLREG_LBA24_27                    0x06
#define ATRLREG_COMMAND                     0x07

#define ATRLREG_SECTORNUM                   0x03
#define ATRLREG_LBALOW                      0x04
#define ATRLREG_LBAHIGH                     0x05
#define ATRLREG_DEVICESELECT                0x06

#define MASTER_DRIVE						0x01
#define SLAVE_DRIVE							0x02

#define SEQ_NO_DELAY            			0xFF

#define NCA_OFFSET_ATAPACKET    			(0x06*4)
#define PSG_OFFSET_ATAPACKET				(0x05*4)
#define CONTROL_OFFSET_ATAPACKET 			(0x04*4)
#define ADDRESS_OFFSET_ATAPACKET			(0x03*4)
#define MODULE_OFFSET_ATAPACKET			(0x02*4)
#define NPA_OFFSET_ATAPACKET				(0x00*4)

#define NCA_OFFSET_HDMA_PACKET    				(0x07*4)
#define PSG1_OFFSET_HDMA_PACKET				(0x06*4)
#define PSG0_OFFSET_HDMA_PACKET				(0x05*4)
#define CONTROL_OFFSET_HDMA_PACKET 			(0x04*4)
#define ADDRESS_OFFSET_HDME_PACKET			(0x03*4)
#define MODULE_OFFSET_HDMA_PACKET			(0x02*4)
#define NPA_OFFSET_HDMA_PACKET				(0x00*4)

#define NCA_OFFSET_XOR_PACKET    				(0x0B*4)
#define PSG5_OFFSET_XOR_PACKET				(0x0A*4)
#define PSG4_OFFSET_XOR_PACKET				(0x09*4)
#define PSG3_OFFSET_XOR_PACKET				(0x08*4)
#define PSG2_OFFSET_XOR_PACKET				(0x07*4)
#define PSG1_OFFSET_XOR_PACKET				(0x06*4)
#define PSG0_OFFSET_XOR_PACKET				(0x05*4)
#define CONTROL_OFFSET_XOR_PACKET 			(0x04*4)
#define ADDRESS_OFFSET_XOR_PACKET			(0X03*4)
#define MODULE_OFFSET_XOR_PACKET				(0x02*4)
#define NPA_OFFSET_XOR_PACKET					(0x00*4)


#define MODULE_IS_BUSY			 			0x01
#define MODULE_IS_IDLE			 			0x00

#define FIXED_SEQID_HDMA					31
#define FIXED_SEQID_XOR30					30
#define FIXED_SEQID_XOR29					29

/*
 definition for ATA_PACKET control					 &&&&&&&&&&     
*/
#define ATA_CONTROL_DIR_WRITE   0x00
#define	ATA_CONTROL_DIR_READ	0x04    /*1 - READ DMA, 0 - WRITE DMA*/
#define ATA_CONTROL_NO_DATA	    0x08    /*1 - non data command*/
#define PCI_CONTROL_DIR_READ    0x00
#define PCI_CONTROL_DIR_WRITE   0x04

/*
 IDE command definitions							 &&&&&&&&&&&&&  
*/

#define IDE_COMMAND_ATAPI_RESET                     0x08
#define IDE_COMMAND_RECALIBRATE                     0x10
#define IDE_COMMAND_SEEK                            0x70
#define IDE_COMMAND_SET_DRIVE_PARAMETERS    0x91
#define IDE_COMMAND_VERIFY                          0x40
#define IDE_COMMAND_ATAPI_PACKET                    0xA0
#define IDE_COMMAND_ATAPI_IDENTIFY                  0xA1
#define IDE_COMMAND_WRITE_DMA                       0xCA
#define IDE_COMMAND_READ_DMA                        0xC8
#define IDE_COMMAND_IDENTIFY                        0xEC
#define IDE_COMMAND_SET_FEATURES           0xEF
#define IDE_COMMAND_SMART                                       0xb0

#define FORCE_DUMP_OFFSET       (0x84 >> 2)

#define scsiREAD_10                     0x28
#define scsiWRITE_10                     0x2A

#define iNDEXIDECommand             0x1c

/* by alloy */

/* this is the head file of packet manager module */

#define MAX_XOR_PAC (256 - 1)
#define XOR_PAC_SIZE 0x40
#define MAX_HDMA_PAC 64
#define HDMA_PAC_SIZE 0x20
#define MAX_ATA_PAC 1024
#define ATA_PAC_SIZE 0x70
#define XOR_BASE_ADDR XOR_PAC_SIZE
#define HDMA_BASE_ADDR (XOR_BASE_ADDR + MAX_XOR_PAC * XOR_PAC_SIZE)
#define ATA_BASE_ADDR (HDMA_BASE_ADDR + MAX_HDMA_PAC * HDMA_PAC_SIZE)
#define SG_TABLE_SIZE 0x100
#define MAX_SG_TABLE 700
#define SG_BASE_ADDR (ATA_BASE_ADDR + MAX_ATA_PAC * ATA_PAC_SIZE)


/* by fanru */

#define MAX_ATA_MODULE_COUNT        31
#define MIN_ATA_MODULE_COUNT        0
#define MAX_XOR_MODULE_COUNT        35
#define MIN_XOR_MODULE_COUNT        32
#define HDMA_MODULE_COUNT           36

#define MAX_SEQUENCES   32

/* by robert */
#define MAX_XOR_SEQ			0x4
#define MAX_XOR_SEQ_QUEUE   	0x20
#define XOR_MODULE_TYPE		33

/* by Jeff */
#ifdef _INVERT_
#define HDMA_INVERT   	0
#define XOR_INVERT		1
#define ATA_INVERT		2
#endif


/* fanru added for 48-bit LBA command [2001-10-11] --- start */
        #define IDE_COMMAND_READ_EXT 				0x24
        #define IDE_COMMAND_READ_DMA_EXT     		0x25
        #define IDE_COMMAND_READ_DMA_QUEUED_EXT  	0x26
        #define IDE_COMMAND_READ_MULTIPLE_EXT    	0x29
        #define IDE_COMMAND_WRITE_EXT            	0x34
        #define IDE_COMMAND_WRITE_DMA_EXT     		0x35
        #define IDE_COMMAND_WRITE_DMA_QUEUED_EXT  	0x36
        #define IDE_COMMAND_WRITE_MULTIPLE_EXT   	0x39
        #define IDE_COMMAND_VERIFY_EXT				0x42
/* fanru added for 48-bit LBA command [2001-10-11] --- end */


/* fanru added for down speed [2001-10-11] --- start */
        #define IDE_CONTROL_STATUS_INDEX			0x48
        #define SOFE_ECC_ERROR_BIT                               1<<23

        #define  ATA_SETFEATURE_DRIVE			0xEF
        #define  BUSY_BIT                                     0x80
        #define  DEFAULT_INT_WAIT                     500
/* fanru added for down speed command [2001-10-11] --- end  */


/* fanru added for IDE Read/Write --- start  */
#define  IDE_DATA_REGISTER                         0
#define  IDE_FEATURE_ERROR_REGISTER        1
#define  IDE_SECTORCOUNT_REGISTER            2
#define  IDE_SECTORNUMBER_REGISTER          3
#define  IDE_CYLINDERLOW_REGISTER             4
#define  IDE_CYLINDERHIGH_REGISTER             5
#define  IDE_DEVICE_HEAD_REGISTER               6
#define  IDE_COMMAND_STATUS_REGISTER       7
#define  IDE_ALTSTATUS_REGISTER             8
/* fanru added for IDE Read/Write --- end  */


/* fanru added for SMBus*/
#ifndef SM_SDA
#define SM_SDA		0x01
#define SM_SCL		0x02

#define SM_ADDRESS_READ 0x01
#define SM_ADDRESS_WRITE 0x00
#endif


//may
/*--- in sx_ata.c -------------------------------------------------*/
/* ATA register defines */
#define ATA_DATA            0x00    /* data register */
#define ATA_ERROR           0x04    /* (R) error register */
#define     ATA_E_NM        0x02    /* no media */
#define     ATA_E_ABORT     0x04    /* command aborted */
#define     ATA_E_MCR       0x08    /* media change request */
#define     ATA_E_IDNF      0x10    /* ID not found */
#define     ATA_E_MC        0x20    /* media changed */
#define     ATA_E_UNC       0x40    /* uncorrectable data */
#define     ATA_E_ICRC      0x80    /* UDMA crc error */

#define ATA_FEATURE         0x04    /* (W) feature register */
#define ATA_COUNT           0x08    /* sector count register */
#define ATA_SECTOR          0x0c    /* sector number register */
#define ATA_CYL_LSB         0x10    /* cylinder low register */
#define ATA_CYL_MSB         0x14    /* cylinder high register */
#define ATA_DRIVE           0x18    /* device/head register */
#define     ATA_D_LBA       0x40    /* use LBA addressing */
#define     ATA_D_IBM       0xa0    /* 512 byte sectors, ECC */
#define ATA_STATUS          0x1c    /* (R) status register */
#define     ATA_S_ERROR     0x01    /* error */
#define     ATA_S_DRQ       0x08    /* data request */
#define     ATA_S_DSC       0x10    /* device seek completed */
#define     ATA_S_SERVICE   0x10    /* device needs service */
#define     ATA_S_DWF       0x20    /* device write fault */
#define     ATA_S_DMA       0x20    /* DMA ready */
#define     ATA_S_READY     0x40    /* device ready */
#define     ATA_S_BUSY      0x80    /* busy */
#define ATA_CMD             0x1c    /* (W) commmand register */
#define     ATA_C_INIT_PARAM        0x91    /* set disk parameters */
#define     ATA_C_SET_MULTI         0xc6    /* set multi size */
#define     ATA_C_ATA_IDENTIFY      0xec    /* get ATA param */
#define     ATA_C_SET_FEATURE       0xef
#define         ATA_C_F_SET_XFER    0x03    /* set xfer mode */

#define ATA_ALT_STAT        0x38    /* (R) alternate status register */
#define ATA_DEV_CTRL        0x38    /* (W) device control register */
#define     ATA_A_IDS       0x02
#define     ATA_A_RESET     0x04
#define ATA_PAC_PAC_P       0x40    /* packet pointer register */
#define ATA_PRD_TABLE       0x44    /* PRD table register */
#define ATA_CGCR            0x48    /* channel global control register */
#define ATA_CTCR0           0x4c    /* config and timing control register */
#define ATA_CTCR1           0x50    /* same as above */
#define ATA_SG_ADDR         0x54    /* SG engine address counter register */
#define ATA_SG_BYTE_C       0x58    /* SG engine byte count register */
#define ATA_NCA             0x5c    /* ATA next command packet register */
#define ATA_CICR            0x60    /* channel IDE control/status register */

/* misc defines */
#define ATA_MASTER          0x00
#define ATA_SLAVE           0x10

#define ATA_DEV(device)     ((device == ATA_MASTER) ? 0 : 1)

/* ATA flags and status */
#define SX_ATA_DMA_ACTIVE   0x01
#define SX_ATA_CONTINUE     0x08    /* do not lose control of ATA module */
#define SX_ATA_NO_XFER_WAIT 0x10
#define SX_ATA_NO_XFER      0x20
#define SX_ATA_XFER         0x40
#define SX_ATA_RESET        0x80

#define SX_ATA_S_IDLE       0x00
#define SX_ATA_S_BUSY       0x01
#define SX_ATA_S_ERROR      0x10

#define SX_CABLE_40         0x40
#define SX_CABLE_80         0x80

#define SX_ATA_WAIT_TIME    5000000   /* 5,000,000 us --- 5 s*/


/*--- in sx_sb.c --------------------------------------------------*/
#define SB_MAP_MASTER       0x01
#define SB_MAP_SLAVE        0x10


/*--- in sx_ad.c --------------------------------------------------*/
#define AD_MAP_MASTER       0x01
#define AD_MAP_SLAVE        0x10

#define AD_S_REBUILDING     0x0001
#define AD_S_REBUILD_FAILED 0x0002

#define SX_STATE_OPEN 0x0001

#define WINBOND_ID 0x5CA3
/* fanru added for SMBus --end*/
