

extern U16 SXInitBlockPool(U8 card_no);
extern U8 SXAllocBlock(U8 card_no);
extern void SXFreeBlock(U8 card_no, U8 Block);
extern U16 SXInitSEQIDPool(U8 card_no);
extern U8 SXAllocSEQID(U8 card_no);
extern void SXFreeSEQID(U8 card_no, U8 SEQID);
extern U8 CheckXORModule(	U8 bAdapterNumber);
extern U8 CheckHDMAModule(
	U8 bAdapterNumber,
	U8 bModuleNumber);
/*extern void MapHDMAIndex(
	bpREQ p_rq,
	PU8 pbAdapterNumber);*/
extern U16 SXInitPacketQ(U8 card_no, pac_q_type q_type);
extern U32 SXAllocPacket(U8 card_no, pac_q_type q_type);
extern void SXFreePacket(U8 card_no, pac_q_type q_type, U32 PacketAddress);
/* << for SG -- add by alloy 20010613 */
extern U16 SXInitSG(U8 card_no);
extern U32 SXAllocSG(U8 card_no);
extern void SXFreeSG(U8 card_no, U32 SGAddress);
extern U32 SubmitHDMA(bpREQ p_rq,apSG p_sg0,apSG p_sg1);
extern void GetFromLocalMem(
	PVOID   pSource,
	U8   bAdapternumber,
	U32   lOffset,
	U32  lSize);             /* in byte,=PacketAddress*/ 
extern void Initialization(void);
//Label_bp begin
extern void CAM_InitSBOX(U8 bAdapterNumber);
//Label_bp end
#ifdef __LINUX__
extern void PrepareHDMAPacket(
	PSX4_HDMA_PACKET pTmpHDMAPacket, 
	bpREQ p_rq, 
	U32 p_sg0,
	U32 p_sg1);
#endif /* __LINUX__ */
/*#else*/
#ifdef NT
extern void PrepareHDMAPacket(
	PSX4_HDMA_PACKET pTmpHDMAPacket, 
	bpREQ p_rq, 
	apSG p_sg0,
	apSG p_sg1);
#endif /* NT */
#ifdef __FreeBSD__
extern void PrepareHDMAPacket(
	PSX4_HDMA_PACKET pTmpHDMAPacket, 
	bpREQ p_rq, 
	U32 p_sg0,
	U32 p_sg1);
#endif /* __FreeBSD__ */


#ifdef netware
extern void PrepareHDMAPacket(
	PSX4_HDMA_PACKET pTmpHDMAPacket, 
	bpREQ p_rq, 
	apSG p_sg0,
	apSG p_sg1);
#endif /* netware */


extern void PutToLocalMem(
	PVOID   pSource,
	U8   bAdapternumber,
	U32   lOffset,
	U32	 lSize);             /* in byte,=PacketAddress*/ 
extern void Q_Packet(
	U8 bAdapterNumber,
	U8 bModuleID,
	U32 PacketAddress);
extern void PrepareATAPacket(
	PSX4_ATA_PACKET pTmpAtaPacket, 
	bpDTASK pDTask, 
	U8 bDelay,
	U8 bSEQID);
extern U8 CheckATAModule(
	U8 bAdapterNumber,
	U8 bModuleNumber);
extern void Sort_Packet(
	U8 bAdapterNumber,
	U8 bModuleID,
	PSX4_ATA_PACKET tmpPacketArray);
void OtherATAOperation1(
	U8	bAdapterNumber,
	U8	bModuleID,
	U8	FreeSeqID);
extern void OtherATAOperation(
	U8	bAdapterNumber,
	U8	bModuleID,
	U8	FreeSeqID,
	PSX4_ATA_PACKET tmpPacketArray);
extern void SubmitATA (IN bpDTASK pDtask);
extern U8 Put2XORQueue(U16 bAdapterNumber,bpSEQ p_sq,U32 p_prd,U16 NumOfPSG);
extern void bGetSeqFromQueue(U8 bAdapterNumber,bpSEQ *bp_seq,PU32 p_prd, U16 *NumberOfPSG);
extern void Put2XORPacketQueue(U8 bAdapterNumber,U8 Num,U32 PacketAddress);
extern void Put2SeqIDQueue(U8 bAdapterNumber,U32 PacketAddress,U8 SeqID);
extern void StartXORModule(U8 bAdapterNumber,U8 FreeSeqID);
extern void SubmitXOR(bpSEQ p_sq);
extern void _call XORReturn(bpSEQ p_sq);
extern void HDMAReturn(bpREQ b_rq);

extern U32 ISR(U32 IRQHandle);
extern void StartHDMAOperation(U8 bAdapterNumber,U8 bModuleID);
extern void StartATAOperation(U8 bAdapterNumber,U8 bModuleID);
extern void StartXOROperation(U8 bAdapterNumber);
void ATASoftResetModule(U8 bAdapterNumber,U8 bModuleId);
/*added by Jeff for ECC 2001/11/21 */
void HDMASoftResetModule(U8 bAdapterNumber,U8 bModuleId);

/*added by Alloy 2001/09/26 for SRAM  functions*/
U32 lGetNonVolatileMemSize(U8 ID);
PU8 pGetNonVolatileMemVirtualAddress(U8 ID,U8 AdapterIndex); //modified by isaac for dualcard
BoOL ReadNonVolatileData(U8 ID, PU32 pSource, PU32 pTargetHost, U32 lLength);
BoOL WriteNonVolatileData(U8 ID, PU32 pSourceHost, PU32 pTarget, U32 lLength);
/*end*/


#ifdef _INVERT_
extern void NegativeData(PUCHAR pSource,U32 lSize);
extern void GetTmpPRD(U32 InvertSize,U8 FreeSEQNum);
extern void SubmitInvert(PVOID pSource,U8 bInvertType);
extern void InvertReturn(PVOID pSource,U8 bInvertType);
extern void ATAReturn(bpDTASK pDtask);
extern U16 SXInitSEQPool(U8 card_no);
extern U8 SXAllocSEQ(U8 card_no);
extern void SXFreeSEQ(U8 card_no, U8 SEQID);
#endif


/* <<-- add by alloy */
void SendSMARTCMD(void);
/*void PrepareSMARTCMD(bpDTASK ptk);
void ExecuteSMARTCMD(U8 ch, U8 id);*/
/* add by alloy -->> */

#ifdef WIN95_ONLY
void WriteRegisterBufferUlong(PU32 pTargetAddr,PU32 pSourceAddr, U32 lLen);
void ReadRegisterBufferUlong(PU32 pSourceAddr,PU32 pTargetAddr, U32 lLen);
#endif



/*fanru added for IDE read/write 2001-10-11 --start */
extern U8   CambReadIDERegister(U8 bAdapterNumber,
                                          U8 bModuleID, 
                                          U8 registerType);

extern void  CambWriteIDERegister(U8 bAdapterNumber,
                                            U8 bModuleID, 
                                            U8 data,
						    U8 registerType);

/*fanru added for IDE read/write 2001-10-11 --start */

/* fanru added for down speed --start*/
extern void DownSpeedDisk(U8 AdapterID,U8 ModuleID,U8 MasterOrSlave);
extern U32 SetDriveFeature(U8 AdapterID,U8 ModuleID,U8 MasterOrSlave);
extern U32 CamWaitForInterrupt(U8 AdapterID, U8 ModuleID,U32 NumberMilliseconds);

/* fanru added for down speed --end*/

