/***************************************************************************
 *
 * Copyright (c) 1995 Promise Technology, Inc.  All rights reserved.
 * No part of this document may be reproduced or transmitted in any form or
 * by any means, electronic or mechanical, for any purpose, without the
 * express written permission of Promise Technology, Inc.
 *
 *
 * 
 *
 ***************************************************************************/

/*
 * bitwise comapre
 */

#define blSet(x, y, z)   ((x & y) == z)
#define blClear(x, y, z) ((x | y) == z)


/*
 * queue entry allocation and release service
 */

#define p_GetFreeEntry(x) p_GetFromQ_Top(x)
#define ReleaseEntry(x ,y) PutToQ_Top(x, y)


/*
 * converts physical address into virutal address.  the physical address must
 * be within the internal buffer's range.  i.e. this routine is only good for
 * variables/bytes allocated from RAID Engine's free pool.
 */

#define p_PhysicalToVirtual(wp_P) ((bpBUF) ((wp_P) + P_To_V_Offset))


/*
 * converts virtual address into physical address.  the virtual address must
 * be within the internal buffer's range.  i.e. this routine is only good for
 * variables/bytes allocated from RAID Engine's free pool.
 */

#define wVirtualToPhysical(p_V) (((unsigned) (p_V)) + V_To_P_Offset)

/*
 *
 */

#define AbsoluteDifference(x, y) ((x > y) ? (x - y) : (y - x))

//Label_bp begin
#define VALID_MAINTENANCE_EVT(aryId) ((p_evMaintenanceEvent[aryId]!=0) && (p_evMaintenanceEvent[aryId]!=(bpEVENT)0xFFFFFFFF))
#define ARRAY_IN_REBUILDING(aryId) (VALID_MAINTENANCE_EVT(aryId) && (p_evMaintenanceEvent[aryId]->bFunction==bRECONSTRUCT_STREAM))
//Label_bp end

