#ifndef __TYPES_H__
#define __TYPES_H__

typedef unsigned long baddr_t;      /* type of block address */
typedef unsigned long bsize_t;      /* type of block size */
typedef unsigned long addr_t;
typedef unsigned long buf_flag_t;   /* type of buffer flag */
typedef unsigned long buf_status_t;
typedef unsigned long buf_flush_flag_t;
typedef unsigned long mm_flag_t;

#ifndef _ASM_IO_H                      //avoid redefination in linux kernel code
typedef unsigned long u32;
typedef char *caddr_t;
#endif

#ifndef ABS
#define ABS(a) ((a)>=0?(a):-(a))
#endif

#ifndef MAX
#define MAX(a, b) (((a) > (b)) ? (a) : (b))
#endif

#ifndef MIN
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#endif

#ifndef howmany
#define	howmany(x, y)	(((x) + ((y) - 1)) / (y))
#endif

#ifndef bzero
#define bzero(addr, size)       mm_memset(addr, 0, size)
#endif


#define DIFF(a,b) ((a)>=(b)?(a)-(b):(b)-(a))


#endif /* __TYPES_H__ */


