/*----------------------------------------------
| Copyright (c) 1995-6   Promise Technology Inc
|
|
| Module Name:
|
|    isr.c
|
| Abstract:
|
| Author:
|
|    fanru 
|
| Revision History:
-------------------------------------------------*/

extern void EnableInt(void);
extern void DisableInt(void);
//extern unsigned long wFreeLocalPoolSize[2];

#define IN
#define OUT


#ifdef __LINUX__
#include "engine/code.h"


#include "engine/constant.h"
#include "engine/struct.h"
#include "cam_con.h"
#include "cam_def.h"
#include "cam_macr.h"
#include "cam_var.h"
#include "cam_export.h"
#include "global.h"
#include <asm/io.h>
#include "wrapper.h"
#define HARDWARE_XOR 1     //added by ganqh 2001/06/13
#define  Jeff 1
extern struct timer_list error_timer_ch0;
extern struct timer_list error_timer_ch1;
extern struct timer_list error_timer_ch2;
extern struct timer_list error_timer_ch3;
extern struct timer_list error_timer_ch4;
extern struct timer_list error_timer_ch5;
extern struct timer_list error_timer_ch6;
extern struct timer_list error_timer_ch7;


extern int buf_init(unsigned long availMemSize, unsigned long availMemSize1);
extern void XORSoftResetModule(U8,U8);
extern void ScsiPortStallExecution(unsigned long);

#endif /* __LINUX__ */
/*#else*/
#ifdef __FreeBSD__

#include <sys/param.h>
#include <sys/systm.h>

#include <machine/bus_pio.h>

typedef unsigned char   U8;
typedef unsigned short  U16;
typedef unsigned long   U32;

#include "../newengine/code.h"
#include "../newengine/constant.h"
#include "../newengine/struct.h"

#include "cam_patch.h"
#include "cam_con.h"
#include "cam_def.h"
#include "cam_var.h"
#include "cam_macr.h"
#include "cam_export.h"
void FillSGToDIMM(U32, apSG, U8);
   
#endif

#ifdef NT
extern int buf_init(unsigned long availMemSize, unsigned long availMemSize1);

#define NT 1
#define HARDWARE_XOR 1     //added by ganqh 2001/06/13
//#define _INVERT_ 1

#ifndef _MMMAP_
//#define _MMMAP_      1
#endif

#include "ntddk.h"

#include "code.h"
#include "constant.h"
#include "struct.h"

#define PVOID void*
#define  ULONG unsigned long
#define  PULONG ULONG*
#define  USHORT unsigned short
#define  PUSHORT USHORT*
#define UCHAR  unsigned char
#define  PUCHAR UCHAR*
#define IN
#define OUT
#define VOID  void

#include "cam_con.h"
#include "cam_def.h"
#include "cam_var.h"
#include "cam_macr.h"
//added by ganqh
#include "cam_export.h"

void
ScsiPortWritePortUlong(
    PULONG Port,
    ULONG Value
    );
//added by ganqh end 

extern ULONG
ScsiPortReadPortUlong(
    IN PULONG Port
    );
VOID
ScsiPortReadRegisterBufferUlong(
    IN PULONG Register,
    IN PULONG Buffer,
    IN ULONG  Count
    );
VOID
ScsiPortWriteRegisterBufferUlong(
    IN PULONG Register,
    IN PULONG Buffer,
    IN ULONG  Count
    );
//added by Jeff 2001/10/25 for win9x
VOID
ScsiPortReadRegisterBufferUchar(
    IN PUCHAR Register,
    IN PUCHAR Buffer,
    IN ULONG  Count
    );
VOID
ScsiPortWriteRegisterBufferUchar(
    IN PUCHAR Register,
    IN PUCHAR Buffer,
    IN ULONG  Count
    );
//end
extern VOID
ScsiPortStallExecution(
    IN ULONG Delay
    );

#endif /* NT */



#ifdef netware
#define HARDWARE_XOR 1     //added by ganqh 2001/06/13

#include "public.h"
#include "ftGlobal.h"
#include "ftDebug.h"

extern int buf_init(unsigned long availMemSize, unsigned long availMemSize1);

#endif




#ifndef __FreeBSD__
#ifndef netware
extern void Sort_Packet(U8 ,U8,PSX4_ATA_PACKET); 
extern void OtherATAOperation(U8 ,U8,U8	,PSX4_ATA_PACKET);
extern void ATAReturn(bpDTASK);
//modified by ganqh
//extern void XORReturn(bpSEQ b_sq);
//extern void HDMAReturn(bpREQ b_rq);
extern void _call XORReturn(bpSEQ b_sq);
extern void HDMAReturn(bpREQ b_rq);

//added by ganqh end
extern void SXFreeSeqID(U8 , U8);
extern void SXFreePacket(U8 , pac_q_type , U32 );
//added by ganqh
#endif
#endif /* __FreeBSD__ */



extern void EnableInt(void);
extern void DisableInt(void);

extern unsigned long wFreeLocalPoolSize[MAX_ADAPTER_NUM];

extern void ChannelReturn(bpDTASK p_tk);
bpDTASK   tmpTask;
bpREQ       tmpReq;

extern PULONG PrepareSG0ForHostDMA(bpDTASK p_tk);

extern U8 SmartStatus[8][2];		/* added by Jeff,for SubmitATA (ide smart command)*/
extern int submitATACount;
extern SMART_INFO SXSMARTInfo;
extern U16 PTIAdapter;
//added by ganqh end

//added by Jeff 2002/04/05
U8 syn_SEQID[MAX_CHANNEL_SUPPORTED];
//added by Jeff 2002/04/05 end

U32 E7_return_count=0;
extern REQ * shuttingREQ;

//remarked by Jeff 2001/09/07
//extern int ataWaitingISR[8];
//extern int hdmaWaitingISR;
//extern int xorWaitingISR;
//end

//ByTE ataCmd,ataCh;
#ifdef NT_DBG
PTIDbgBreakPoint()
{
DbgPrint("FF break point \n");	
DbgBreakPoint();
}	
#endif

U32 ISR(U32 IRQHadle)
{   
//moved here by isaac according to kernel's advice
ByTE ataCmd,ataCh;
U32 INTStatus;
U8 currentINTSeqID=0;
U8 currentAdapterID=0;
U32 currentSeqCS;     /*the value of Sequence Control&Status register*/   

U32 ModuleType;

U8 currentModuleID=0;
//U32 dTaskErrorStatus;
U8 i,j;
U8 InterruptSEQID[32];
U8 InterruptCount=0;
U8 idx;

/* fanru added for down speed --start*/
#ifdef _DOWNSPEED_
	U32 GlobalControlStatus;
#endif
/* fanru added for down speed --end*/


//removed by Jeff 2001/10/09 by changyi's advices
//SX4_ATA_PACKET  tmpPacketArray[MAX_ATA_QUEUE_DEPTH];

DisableInt();
	
INTStatus=0;
for(i=0;i<PTIAdapter;i++)
//for(i=0;i<MAX_ADAPTER_NUM;i++)
{   
    /*decide if this interrupr is our cards'*/
	if(gAdapterConfigInfo.IRQ[i]==IRQHadle)
	{
	    /*------------------------------------------------------
        | Read "Sequence Interrupt Status register" of adapter i, 
	    | to find which sequence has generated a interrupt,       
	    | i.e. to get currentINTSeqID ,                           
	    | at the same time clear interrupt.                       
	    ------------------------------------------------------*/

	#ifdef _MMMAP_
        ReadSEQPort(gAdapterConfigInfo.MMIOBaseAddress[i],(0x80+0xc0400),INTStatus);
	#else
        ReadSEQPort(gAdapterConfigInfo.SEQBaseAddress[i],(0x80>>2),INTStatus);
	#endif
        if(INTStatus!=0)
        {
            currentAdapterID=i;

     /*       j=0;
            while((INTStatus&1)==0)
            {   
               INTStatus=INTStatus>>1;
               j++;            
            }
            currentINTSeqID=j;
           
            break;  */
		j=0;
          do{
          	if ((INTStatus&((U32)1))==1){
			InterruptSEQID[InterruptCount]=j+i*32;
          		InterruptCount++;
          		}
		INTStatus=INTStatus>>1;
          	j++;
        }while(j!=32);
        }
    }    
}      
//modified by isaac for compatiable problem according to novice's advice
       {
			if(InterruptCount==0){
				EnableInt();
				return 0;  /* for netware should return 0 if this interrupt is not ours */   
			}
       }

//if(INTStatus==0){
//	EnableInt();
//    return 0;  /* for netware should return 0 if this interrupt is not ours */   
//}

//if (InterruptCount>1)
//	PTIPTIDbgBreakPoint();

for(idx=0;idx<InterruptCount;idx++)
{

	currentINTSeqID=InterruptSEQID[idx];
 /*-------------------------------------------
 | free  currentINTSeqID , not free now
 ---------------------------------------------*/
 /*SXFreeSeqID(currentAdapterID,currentINTSeqID);
 */

 /*------------------------------------------------------------
 | Read "Sequence(currentINTSeqID ) Control & Status register", 
 | to get error status of each module.  
 --------------------------------------------------------------*/
#ifdef _MMMAP_
    ReadSEQPort(gAdapterConfigInfo.MMIOBaseAddress[currentAdapterID],(currentINTSeqID*4+0xc0400),currentSeqCS);
#else
    ReadSEQPort(gAdapterConfigInfo.SEQBaseAddress[currentINTSeqID/32],currentINTSeqID%32,currentSeqCS);
#endif
  
 
 /*--------------------------------------------------------------------------------   	
 | find all the dTasks of this sequence from SEQID2PacketHead[MAX_ADAPTER_NUM][32];. 
 | set status of dTask,free command packet memory,
 | exchange ping pong , stop DMA transfer ,
 | delete timer and return.
 ---------------------------------------------------------------------------------*/

 	{
 	U64   tmp;
 	U32   loffset;

 	loffset=SEQID2PacketHead[currentINTSeqID/32][currentINTSeqID%32];
 	if (loffset==U32NULL){
 		ModuleType=U32NULL;
 	}else{
 	//modified by Jeff for ECC 2001/11/22
 	GetFromLocalMem(&tmp, currentINTSeqID/32,loffset+MODULE_OFFSET_ATAPACKET, sizeof(U64));   
 	//GetFromLocalMem(&tmp, currentAdapterID,loffset+8 , sizeof(U64));   
	ModuleType=*((U32*)&tmp);
 		}
 	}


DBC(printk("<1>ISR:ModuleType=%x,CurrentINTSeqID=%x,CurrentSeqCS=%lx\n",ModuleType,currentINTSeqID,currentSeqCS));
/* for sendsmartcommand's interrupt */
if (ModuleType==U32NULL)
{	
/* <<-- added by alloy */
	U8 ch, id, status;
	U8	index;

	/* smart operation */
	if (currentINTSeqID == SXSMARTInfo.seqid) {
		ch = SXSMARTInfo.bCh;
		id = SXSMARTInfo.bID;
#ifdef __LINUX__
		ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[ch/4], ch%4, 0x1c, &status);
#else
#ifndef __FreeBSD__
		ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[ch/4], ch%4, 0x1c, status);
#endif /* __FreeBSD__ */
#ifdef __FreeBSD__
		ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[ch/4], ch%4, 0x1c, &status);
#endif /* __FreeBSD__ */
#endif /*  linux */
		if (SXSMARTInfo.cmd == 0xd8) {
			/* enable smart */
			if ((status & 0xe9) == 0x40) {
				SmartStatus[ch][id] = SMART_OK;
			} else {
				SmartStatus[ch][id] = NO_SMART;
			}
		} else {
			/* returen smart status */
			if ((status & 0xe9) == 0x40) {
#ifdef __LINUX__
				ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[ch/4], ch%4, 0x14, &status);
#else
#ifndef __FreeBSD__
				ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[ch/4], ch%4, 0x14, status);
#endif /* __FreeBSD__ */
#ifdef __FreeBSD__
				ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[ch/4], ch%4, 0x14, &status);
#endif /* __FreeBSD__ */
#endif /* linux */
				if (status == 0x2c) {
					SmartStatus[ch][id] = SMART_ERROR;
				} else {
#ifdef __LINUX__
				ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[ch/4], ch%4, 0x10, &status); //modified by isaac for bug
#else
#ifndef __FreeBSD__
					ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[ch/4], ch%4, 0x10, status);
#endif /* __FreeBSD__ */
#ifdef __FreeBSD__
					ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[ch/4], ch%4, 0x10, &status);
#endif /* __FreeBSD__ */
#endif /* linux */
					if (status == 0xf4) {
						SmartStatus[ch][id] = SMART_ERROR;
					} else {
						SmartStatus[ch][id] = SMART_OK;
					}
				}
			} else {
				SmartStatus[ch][id] = NO_SMART;
			}
		}
		SXFreeSEQID(currentINTSeqID/32, currentINTSeqID%32);//modified by isaac for bug
		SXSMARTInfo.finish = 0;
		ataWaitingISR[ch] = 0;
		//added by Jeff for ATATimer 2001/09/07
		ATATimer[ch*2]=0;
		ATATimer[ch*2+1]=0;
		//end
		if (HDMAModuleNeedPush[0]){
			StartHDMAOperation(HDMAAdapterNeedPush[0],HDMAModuleIDNeedPush[0]);
		}
		if (HDMAModuleNeedPush[1]){
			StartHDMAOperation(HDMAAdapterNeedPush[1],HDMAModuleIDNeedPush[1]);
		}
		/* xor push need here */
		for(index=0;index<MAX_ADAPTER_NUM;index++)
			if (XORModuleNeedPush[index])
				StartXOROperation(XORAdapterNeedPush[index]);
		/* ata push need here */
 	      if (ATAPushDirectionS2L){
			for(index=0;index<16;index++)
				if (ATAModuleNeedPush[index])
					StartATAOperation(ATAAdapterNeedPush[index],ATAModuleIDNeedPush[index]);
		}else{
			for(index=0;index<16;index++)
				if (ATAModuleNeedPush[15-index])
					StartATAOperation(ATAAdapterNeedPush[15-index],ATAModuleIDNeedPush[15-index]);
		}
		ATAPushDirectionS2L^=1;              
		continue;
	}
/* added by alloy -->> */
#if 0	
/* wilbery open for other command */
	
	//bINTType = plocalAdapterExtension->SeqIntType[currentINTSeqID];//==
       //plocalAdapterExtension->SeqIntType[currentINTSeqID] = 0;//==
	

       if      ( bINTType[currentINTSeqID]== 0x04)//SEQ_INT_TYPE_NODATA
                {
                //U8   idx;

			bINTType[currentINTSeqID]=0;
                
                    //
                    // dTAsk done as read operation and seq INT is HDMA or
                    //               write operation and seq INT is ATA xfer.
                    // 
	        if (NondatapDTask[currentINTSeqID])
	        {	            
	            ataWaitingISR[(NondatapDTask[currentINTSeqID]->bCh)] = 0;                    /* wilbery add for channel ready */
                    NondatapDTask[currentINTSeqID]->bStatus =0x04;// BUSMASTER_STATUS_NOERROR;
    		      NondatapDTask[currentINTSeqID]->ata_reg.cmd.bStatus =0x50; //IDE_STATUS_IDLE;
			SXFreeSEQID(currentINTSeqID/32, currentINTSeqID%32);
			#ifdef NT_DEBUG_PRINT
				E7_return_count++;
				DbgPrint("&&&&   ----   E7 RETURN COUNT=0x %x   \n",E7_return_count/2);	
			#endif
                    ChannelReturn(NondatapDTask[currentINTSeqID]);
	        }
//			EnableInt();
//        	      return 1;
			continue;
       	}
#endif
}



/*----------------------
| for ATA
----------------------*/
if((ModuleType<=MAX_ATA_MODULE_COUNT))
{
	bpDTASK   pDtask;
	SX4_ATA_PACKET  tmpPacket;
	U32    loffset;
	PSX4_ATA_PACKET   CurrentPacket;

	DisableInt();
	submitATACount--;
	EnableInt();
#ifdef __LINUX__
	memset(&tmpPacket,0,sizeof(SX4_ATA_PACKET));
#endif



       CurrentPacket=&tmpPacket;
	loffset=SEQID2PacketHead[currentINTSeqID/32][currentINTSeqID%32];
	SEQID2PacketHead[currentINTSeqID/32][currentINTSeqID%32]=U32NULL;
	SEQID2PacketTail[currentINTSeqID/32][currentINTSeqID%32]=U32NULL;
       GetFromLocalMem(&tmpPacket,currentINTSeqID/32,loffset,sizeof(SX4_ATA_PACKET) );

    	 /*------------------------------
    	 | delete timer
    	 ------------------------------*/
        
#ifdef __LINUX__
	switch(((bpDTASK)((PSX4_ATA_PACKET)CurrentPacket)->PacketHead.PTA)->bCh)        {
		case 0: PTI_del_timer((struct PTI_timer_list* )(&error_timer_ch0));
			PTI_drive[0].cpending=0;
			break;
		case 1: PTI_del_timer((struct PTI_timer_list* )(&error_timer_ch1));
			PTI_drive[2].cpending=0;
			break;
		case 2: PTI_del_timer((struct PTI_timer_list* )(&error_timer_ch2));
			PTI_drive[4].cpending=0;
			break;
		case 3: PTI_del_timer((struct PTI_timer_list* )(&error_timer_ch3));
			PTI_drive[6].cpending=0;
			break;
		case 4: PTI_del_timer((struct PTI_timer_list* )(&error_timer_ch4));
			PTI_drive[8].cpending=0;
			break;
		case 5: PTI_del_timer((struct PTI_timer_list* )(&error_timer_ch5));
			PTI_drive[10].cpending=0;
			break;
		case 6: PTI_del_timer((struct PTI_timer_list* )(&error_timer_ch6));
			PTI_drive[12].cpending=0;
			break;
		case 7: PTI_del_timer((struct PTI_timer_list* )(&error_timer_ch7));
			PTI_drive[14].cpending=0;
			break;

	}
#endif  
 




    while(CurrentPacket!=ZERO_NULL)
	{
		currentModuleID=(((bpDTASK)((PSX4_ATA_PACKET)CurrentPacket)->PacketHead.PTA)->bCh);

         /*-------------------------------------------------------------------
         | if there are errors about this ATA module,
         | read IDE #(currentModuleID) Global Control & Status Register
         | and set status of dTask.
         --------------------------------------------------------------------*/
   		 //temp=1<<(currentModuleID%4+16);
		 if(currentSeqCS&(1<<(currentModuleID+16))) 
   		 {
			U8    bStatus=0;

#ifdef NT_DBG	

			//added for debug for conversion 2001/12/19
			{
			U32		tmpdata;
			U32		dd;
			ReadIDEIndex(gAdapterConfigInfo.MMIOBaseAddress[currentModuleID/4], currentModuleID%4, 0x48, tmpdata);
			//DbgPrint("tmpdata= \n");
			//DbgPrint("tmpdata= %x \n",tmpdata);
			//DbgPrint("tmpdata= \n");

                        DbgPrint("Break 21\n");

			PTIDbgBreakPoint();
			dd=0;
			dd++;
			}
#endif
			//reset module 
			ATASoftResetModule(currentModuleID/4, currentModuleID%4);

			pDtask=(bpDTASK)((PSX4_ATA_PACKET)CurrentPacket)->PacketHead.PTA;
          
			ataCh=pDtask->bCh;
			ataCmd=pDtask->ata_reg.cmd.bCmd;

	              pDtask->bStatus =0x02; //BUSMASTER_STATUS_ERROR;
#ifdef __LINUX__
			ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[currentModuleID/4],currentModuleID%4, iNDEXIDECommand, &bStatus);
#else
#ifndef __FreeBSD__
			ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[currentModuleID/4],
				    currentModuleID%4, iNDEXIDECommand, bStatus);
#endif /* __FreeBSD__ */
#ifdef __FreeBSD__
			ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[currentModuleID/4],
				    currentModuleID%4, iNDEXIDECommand, &bStatus);
#endif /* __FreeBSD__ */
#endif /* linux */
			pDtask->ata_reg.cmd.bStatus =bStatus;
			#ifdef _INVERT_
				ATAReturn(pDtask);
			#else
				ChannelReturn(pDtask);
			#endif


			  /* fanru added for down speed --start*/
			#ifdef _DOWNSPEED_
#ifndef __FreeBSD__
				ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[currentModuleID/4],
				    currentModuleID%4, IDE_CONTROL_STATUS_INDEX, GlobalControlStatus);  /* Global Control & Status Register */
#endif /* __FreeBSD__ */
#ifdef __FreeBSD__
				ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[currentModuleID/4],
				    currentModuleID%4, IDE_CONTROL_STATUS_INDEX, &GlobalControlStatus);  /* Global Control & Status Register */
#endif /* __FreeBSD__ */


				if(GlobalControlStatus&SOFE_ECC_ERROR_BIT)
				{
#ifdef NT_DBG	
					DbgPrint("Break 22\n");
					PTIDbgBreakPoint();
#endif
					DownSpeedDisk(currentModuleID/4,currentModuleID%4,0);
				}		
			#endif
                    /* fanru added for down speed --end*/


			

		    	 /*------------------------------
		    	 | free packet command memory
		    	 ------------------------------*/
	    	 SXFreePacket(currentModuleID/4, ATA_PAC, loffset);

//			if ((ataCmd!=IDE_COMMAND_SMART)&&(ataCmd!=IDE_COMMAND_VERIFY)){
//				SXFreeSG(currentINTSeqID/32,tmpPacket.ATAPacket.ulPSG);
//			}
                     if ((ataCmd!=IDE_COMMAND_SMART)&&(ataCmd!=IDE_COMMAND_VERIFY) && 
                             (ataCmd!=0xe7)){
                             SXFreeSG(currentModuleID/4,tmpPacket.ATAPacket.ulPSG);
                     }

			if ((ataCmd==IDE_COMMAND_SMART)){
				SmartStatus[pDtask->bCh][pDtask->bID]=SMART_OK;
			}

			loffset=CurrentPacket->PacketHead.NPA;
			while(loffset!=U32NULL){
			    	 CurrentPacket=&tmpPacket;
				 GetFromLocalMem(&tmpPacket,currentModuleID/4,loffset,sizeof(SX4_ATA_PACKET) );
				 Q_Packet(currentModuleID/4, currentModuleID%4, CurrentPacket->PacketHead.Address);
				 loffset=CurrentPacket->PacketHead.NPA;
			}
			
		    	 if (loffset==U32NULL){
				U8	index;

				SXFreeSEQID(currentINTSeqID/32, currentINTSeqID%32);


				ataWaitingISR[ataCh]=0;
				//added by Jeff for ATATimer 2001/09/07
				ATATimer[ataCh*2]=0;
				ATATimer[ataCh*2+1]=0;
				//end

				if (HDMAModuleNeedPush[0]){
					StartHDMAOperation(HDMAAdapterNeedPush[0],HDMAModuleIDNeedPush[0]);
				}
				if (HDMAModuleNeedPush[1]){
					StartHDMAOperation(HDMAAdapterNeedPush[1],HDMAModuleIDNeedPush[1]);
				}
				/* xor push need here */
				for(index=0;index<MAX_ADAPTER_NUM;index++)
					if (XORModuleNeedPush[index])
						StartXOROperation(XORAdapterNeedPush[index]);
				/* ata push need here */
			if (ATAPushDirectionS2L){
					for(index=0;index<16;index++)
						if (ATAModuleNeedPush[index])
							StartATAOperation(ATAAdapterNeedPush[index],ATAModuleIDNeedPush[index]);
				}else{
					for(index=0;index<16;index++)
						if (ATAModuleNeedPush[15-index])
							StartATAOperation(ATAAdapterNeedPush[15-index],ATAModuleIDNeedPush[15-index]);
				}
				ATAPushDirectionS2L^=1;              
		    	 	break;
		    	 }		    	 
       	 }
	     else
    	 {
           //set status of dTask to successfull
           ((bpDTASK)((PSX4_ATA_PACKET)CurrentPacket)->PacketHead.PTA)->bStatus=0;
    	 }
	//modified by ganqh
    	//ATAReturn ((bpDTASK)((PSX4_ATA_PACKET)CurrentPacket)->PacketHead.PTA);
	pDtask=(bpDTASK)((PSX4_ATA_PACKET)CurrentPacket)->PacketHead.PTA;



#ifdef NT_DBG	

		//added for debug for conversion 2001/12/19
		{
		U32		tmpdata;
		U32		dd;
		ReadIDEIndex(gAdapterConfigInfo.MMIOBaseAddress[currentModuleID/4], currentModuleID%4, 0x48, tmpdata);

//		DbgPrint("tmpdata= \n");
//		DbgPrint("tmpdata= %x \n",tmpdata);
//		DbgPrint("tmpdata= \n");

		dd=0;
		dd++;
		}
#endif


//    	if (ReadingReservedSector && bBufNeedInit){
     if ((pDtask->blCmdFlag & VIRTUAL_OPCODE) && (pDtask->blCmdFlag & ENGINE_DTASK) ){
  	       bpREQ p_rq;
	       bpSEQ p_sq;
		U32    statusDword;
//		apSG  tmpPsg;
//		U8		i;
	       
		tmpTask=pDtask;
	       p_sq = *((bpSEQ *) &pDtask->p_sq);
	       p_rq = *((bpREQ *) &p_sq->param.p_rq);
//		p_rq->bCDB[0]=IDE_COMMAND_READ;
//		tmpReq=p_rq;   
//		pDtask->p_PRD=pDtask->p_PRD_Channel;
//		tmpPsg=(apSG)PrepareSG0ForHostDMA(pDtask);
//		SubmitHDMA(p_rq, (apSG)tmpPsg, BridgePrd); 
//		ATAPacketQCount[currentAdapterID][currentINTSeqID]=0;

             statusDword = ScsiPortReadPortUlong( gAdapterConfigInfo.SEQBaseAddress[currentINTSeqID/32]+ (currentINTSeqID%32));


		pDtask->p_PRD=pDtask->p_PRD_Channel;
              pDtask->bStatus = 0x04;//BUSMASTER_STATUS_NOERROR;
		pDtask->ata_reg.cmd.bStatus =0x50;// IDE_STATUS_IDLE;
#ifdef __LINUX__
              if ((pDtask->blCmdFlag & DATA_IN) &&((pDtask->ata_reg.cmd.bCmd==IDE_COMMAND_READ)||(pDtask->ata_reg.cmd.bCmd==IDE_COMMAND_READ_DMA))){
#else
           if ((pDtask->blCmdFlag & DATA_IN) &&(pDtask->ata_reg.cmd.bCmd==IDE_COMMAND_READ)){
#endif
			GetFromLocalMem(p_rq->p_buf, pDtask->bCh/4, (0x160000+(((pDtask->bCh)%4)*2+pDtask->bID)*0x10000), (pDtask->hSize*2));
              }
		#ifdef _INVERT_
		NegativeData((PUCHAR)p_rq->p_buf, 0x800);
		#endif
	    	#ifdef _MMMAP_
	    	WriteSEQPort(gAdapterConfigInfo.MMIOBaseAddress[pDtask->bCh/4], 0xc0400+0x84, 0x01);
	    	#else
     		WriteSEQPort(gAdapterConfigInfo.SEQBaseAddress[pDtask->bCh/4], FORCE_DUMP_OFFSET, 0x01);
	    	#endif
		if(ReadingReservedSector!=0)
    			ReadingReservedSector--;
		ataCh=pDtask->bCh;
		ataCmd=pDtask->ata_reg.cmd.bCmd;
//		for (i=0;i<10;i++){
//			ScsiPortStallExecution(50000);
//		}
		//modified by isaac according to kernel's advice
                //ataWaitingISR[ataCh]=0;

		//added by Jeff for ATATimer 2001/09/07
		//ATATimer[ataCh*2]=0;
		//ATATimer[ataCh*2+1]=0;
		//end

		ChannelReturn(pDtask);
		if(ReadingReservedSector==0 && bBufNeedInit){
			bBufNeedInit=FALSE;
			#ifdef DIS_PBM
                        //added by isaac for dualcard
                        if (wFreeLocalPoolSize[1] == 0) buf_init(wFreeLocalPoolSize[0]-(wPHY_BUFFER_SIZE)-0x800000,0);
			else buf_init(wFreeLocalPoolSize[0]-(wPHY_BUFFER_SIZE)-0x800000, wFreeLocalPoolSize[1]-(wPHY_BUFFER_SIZE)-0x800000);
			#else
                        //added by isaac for dualcard
                        if (wFreeLocalPoolSize[1] == 0) buf_init(wFreeLocalPoolSize[0]-(wPHY_BUFFER_SIZE)-0x380000,0);
			else buf_init(wFreeLocalPoolSize[0]-(wPHY_BUFFER_SIZE)-0x380000, wFreeLocalPoolSize[1]-(wPHY_BUFFER_SIZE)-0x380000);
			#endif
		}
    	}
    	else{
		U8    bStatus=0;

		ataCh=pDtask->bCh;
		ataCmd=pDtask->ata_reg.cmd.bCmd;

              pDtask->bStatus =0x04; //BUSMASTER_STATUS_NOERROR;
#ifdef __LINUX__
		ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[currentModuleID/4],currentModuleID%4, iNDEXIDECommand, &bStatus);
#else
#ifndef __FreeBSD__
		ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[currentModuleID/4],
			    currentModuleID%4, iNDEXIDECommand, bStatus);
#endif /* __FreeBSD__ */
#ifdef __FreeBSD__
		ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[currentModuleID/4],
			    currentModuleID%4, iNDEXIDECommand, &bStatus);
#endif /* __FreeBSD__ */
#endif /* linux */
		pDtask->ata_reg.cmd.bStatus =bStatus;// IDE_STATUS_IDLE;
		#ifdef _INVERT_
			ATAReturn(pDtask);
		#else
		//Label_bp begin
	    DISK_ACCESS[currentModuleID/4][currentModuleID%4] = HDActiveON;
        //Label_bp end
			ChannelReturn(pDtask);
		#endif
    	}		
	//modified by ganqh end
	
    	 /*------------------------------
    	 | free packet command memory
    	 ------------------------------*/
    	 SXFreePacket(currentINTSeqID/32, ATA_PAC, loffset);

         #ifdef NT_DEBUG_PRINT
		if (ataCmd==0xe7)
         		DbgPrint(" 0xE7 command return!, shuttingReq=0x%x \n",shuttingREQ);
         #endif

//	if ((ataCmd!=IDE_COMMAND_SMART)&&(ataCmd!=IDE_COMMAND_VERIFY)){
//		SXFreeSG(currentAdapterID,tmpPacket.ATAPacket.ulPSG);
//	}
       if ((ataCmd!=IDE_COMMAND_SMART)&&(ataCmd!=IDE_COMMAND_VERIFY) && 
             (ataCmd!=0xe7)){
             SXFreeSG(currentINTSeqID/32,tmpPacket.ATAPacket.ulPSG);
       }

	if ((ataCmd==IDE_COMMAND_SMART)){
		SmartStatus[pDtask->bCh][pDtask->bID]=SMART_OK;
	}

    	 /*------------------------------
    	 | delete timer
    	 ------------------------------*/
         /*
    	      code
    	 */
		loffset=CurrentPacket->PacketHead.NPA;
    	 if (loffset==U32NULL){
		U8	index;

		SXFreeSEQID(currentINTSeqID/32, currentINTSeqID%32);
        //moved here by isaac for multi packet in queue problem
			ataWaitingISR[ataCh]=0;
			//added by Jeff for ATATimer 2001/09/07
			ATATimer[ataCh*2]=0;
			ATATimer[ataCh*2+1]=0;
			//end


		if (HDMAModuleNeedPush[0]){
			StartHDMAOperation(HDMAAdapterNeedPush[0],HDMAModuleIDNeedPush[0]);
		}
		if (HDMAModuleNeedPush[1]){
			StartHDMAOperation(HDMAAdapterNeedPush[1],HDMAModuleIDNeedPush[1]);
		}
		/* xor push need here */
		for(index=0;index<MAX_ADAPTER_NUM;index++)
			if (XORModuleNeedPush[index])
				StartXOROperation(XORAdapterNeedPush[index]);
		/* ata push need here */
		if (ATAPushDirectionS2L){
			for(index=0;index<16;index++)
				if (ATAModuleNeedPush[index])
					StartATAOperation(ATAAdapterNeedPush[index],ATAModuleIDNeedPush[index]);
		}else{
			for(index=0;index<16;index++)
				if (ATAModuleNeedPush[15-index])
					StartATAOperation(ATAAdapterNeedPush[15-index],ATAModuleIDNeedPush[15-index]);
		}
		ATAPushDirectionS2L^=1;
    	 	break;
    	 }
    	 CurrentPacket=&tmpPacket;
	 GetFromLocalMem(&tmpPacket,currentINTSeqID/32,loffset,sizeof(SX4_ATA_PACKET) );

	}
}/*end of ATA*/


/*----------------------
| for XOR
----------------------*/
if(ModuleType>=MIN_XOR_MODULE_COUNT&&ModuleType<=MAX_XOR_MODULE_COUNT)  
{
	SX4_XOR_PACKET  tmpPacket;
	U32    loffset;
	PSX4_XOR_PACKET   CurrentPacket;

	/* added by Jeff for SYNCRONIZE 2002/01/04 */
	bpSEQ   pTmpSq;    
	/* end */
	
       CurrentPacket=&tmpPacket;
	loffset=SEQID2PacketHead[currentINTSeqID/32][currentINTSeqID%32];
	SEQID2PacketHead[currentINTSeqID/32][currentINTSeqID%32]=U32NULL;
	SEQID2PacketTail[currentINTSeqID/32][currentINTSeqID%32]=U32NULL;
       GetFromLocalMem(&tmpPacket,currentINTSeqID/32,loffset,sizeof(SX4_XOR_PACKET) );

    while(CurrentPacket!=ZERO_NULL)
	{
		 currentModuleID=0;

        	 
         /*-------------------------------------------------------------------
         | if there are errors about this XOR module,
         | read XOR #(currentModuleID) Global Control & Status Register
         | and set status of dTask.
         --------------------------------------------------------------------*/
   		 if(currentSeqCS&(1<<(currentModuleID+8)))  
   		 {

             /*
             ReadXORPort(ADAPTER_CONFIG_INFO.XORBaseAddress[currentAdapterID], \
                     0x40+0x10*currentModuleID+0x04, dTaskErrorStatus)    	

             switch (dTaskErrorStatus)
			 {
				case Soft ECC error:
                     ....
					 break;

				case HARD ECC Error:
					 ....	
					 break;

				case Drive Error:
					 ....
					 break;
				
				case Under Run Error:
   					 ....
					 break;	
				 
				case SG Abort:
					 ....
					 break;	
			}//end of switch
			*/
		/* added by Jeff for SYNCRONIZE 2002/01/04 */
		U32		tmpdata;

		#ifdef _MMMAP_
		ReadXORIndex(gAdapterConfigInfo.MMIOBaseAddress[currentINTSeqID/32], currentModuleID, 0x04, tmpdata);
		#else
		ReadXORIndex(gAdapterConfigInfo.XORBaseAddress[currentINTSeqID/32], currentModuleID, 0x04, tmpdata);
		#endif
		pTmpSq=(bpSEQ )((PSX4_XOR_PACKET)CurrentPacket)->PacketHead.PTA;
		//modified by Jeff for fix the problem when doing xor,still set the comparing related flag. 
		if (pTmpSq->blFlag & blIsCompare){
			if (tmpdata&0x00200000){
				g_syncErrorFlag=1;
				pTmpSq->blFlag|=blCompareNotSame;
			}else{		
				pTmpSq->blFlag|=blHardwareError;
			}
		}
		XORSoftResetModule(currentINTSeqID/32, currentModuleID);
		/* end */
      	 }
     else
    	 {
	    /* added by Jeff for SYNCRONIZE 2002/01/04 */
           //set status of dTask to successfull
		pTmpSq=(bpSEQ )((PSX4_XOR_PACKET)CurrentPacket)->PacketHead.PTA;
		//modified by Jeff for fix the problem when doing xor,still set the comparing related flag. 
		if (pTmpSq->blFlag & blIsCompare){
			pTmpSq->blFlag|=blCompareSame;
		}
	   /* end */	
    	 }
//	XORPacketQCount[currentAdapterID][currentINTSeqID]=0;
	XORReturn((bpSEQ )((PSX4_XOR_PACKET)CurrentPacket)->PacketHead.PTA);

    	 /*------------------------------
    	 | free packet command memory
    	 ------------------------------*/
    	 SXFreePacket(currentINTSeqID/32, XOR_PAC, loffset);
    	 {
    	 	U8    count=0;
    	 	while(1){
    	 		if (tmpPacket.XORPacket.ulPSG[count]==0)
    	 			break;
		 	SXFreeSG(currentINTSeqID/32,tmpPacket.XORPacket.ulPSG[count]);
		 	count++;
    	 	}
    	 }
         /*------------------------------
    	 | delete timer
    	 ------------------------------*/
    	 /*
                 code ????
    	 */
    	 
		loffset=CurrentPacket->PacketHead.NPA;
    	 if (loffset==U32NULL){
    	 		U8	index;
			SXFreeSEQID(currentINTSeqID/32, currentINTSeqID%32);
	
			
			
			xorWaitingISR[currentINTSeqID/32]=0;
			
			
			/* hdma push here */
			if (HDMAModuleNeedPush[0]){
				StartHDMAOperation(HDMAAdapterNeedPush[0],HDMAModuleIDNeedPush[0]);
			}
			if (HDMAModuleNeedPush[1]){
				StartHDMAOperation(HDMAAdapterNeedPush[1],HDMAModuleIDNeedPush[1]);
			}
			/* xor push  here */
			for(index=0;index<MAX_ADAPTER_NUM;index++)
				if (XORModuleNeedPush[index])
					StartXOROperation(XORAdapterNeedPush[index]);
			/* ata push  here */
			if (ATAPushDirectionS2L){
				for(index=0;index<16;index++)
					if (ATAModuleNeedPush[index])
						StartATAOperation(ATAAdapterNeedPush[index],ATAModuleIDNeedPush[index]);
			}else{
				for(index=0;index<16;index++)
					if (ATAModuleNeedPush[15-index])
						StartATAOperation(ATAAdapterNeedPush[15-index],ATAModuleIDNeedPush[15-index]);
			}
			ATAPushDirectionS2L^=1;
	    	 	break;
    	 	}
	    	CurrentPacket=&tmpPacket;
	       GetFromLocalMem(&tmpPacket,currentINTSeqID/32,loffset,sizeof(SX4_XOR_PACKET) );
	}
}/* end of XOR*/


/*----------------------
| for HDMA
----------------------*/
if(ModuleType==HDMA_MODULE_COUNT)
{
	SX4_HDMA_PACKET  tmpPacket;
	U32    loffset;
	PSX4_HDMA_PACKET   CurrentPacket;

       CurrentPacket=&tmpPacket;
	loffset=SEQID2PacketHead[currentINTSeqID/32][currentINTSeqID%32];
	SEQID2PacketHead[currentINTSeqID/32][currentINTSeqID%32]=U32NULL;
	SEQID2PacketTail[currentINTSeqID/32][currentINTSeqID%32]=U32NULL;
       GetFromLocalMem(&tmpPacket,currentINTSeqID/32,loffset,sizeof(SX4_HDMA_PACKET) );

    while(CurrentPacket!=ZERO_NULL)
	{
		 currentModuleID=0;

        	 
         /*-------------------------------------------------------------------
         | if there are errors about this HDMA module,
         | read HDMA #(currentModuleID) Global Control & Status Register
         | and set status of dTask.
         --------------------------------------------------------------------*/
   		 if(currentSeqCS&(1<<(currentModuleID+12)))
   		 {
			U32	PacketAddress;

#ifdef NT_DBG	
			DbgPrint("Break 23\n");
			PTIDbgBreakPoint();

			//added for debug for ECC 2001/11/21
			{
			U32		tmpdata;
			U32		dd;
			//ReadHDMAIndex(gAdapterConfigInfo.MMIOBaseAddress[currentModuleID/4], currentModuleID%4, 0x04, tmpdata);

			dd=0;
			dd++;
			}
#endif

			//reset module 
			HDMASoftResetModule(currentINTSeqID/32, currentModuleID%4);

			ScsiPortStallExecution(50000);
			ScsiPortStallExecution(50000);

			HDMAPacketQCount[currentINTSeqID/32]++;
			PacketAddress=CurrentPacket->PacketHead.Address;
			if (HDMAPacketQHead[currentINTSeqID/32]==U32NULL){
				HDMAPacketQHead[currentINTSeqID/32]=PacketAddress;
				HDMAPacketQTail[currentINTSeqID/32]=PacketAddress;
			}
			else{
				U64    tmp;
				/*get the original nca value */
				GetFromLocalMem(&tmp, currentINTSeqID/32,HDMAPacketQTail[currentINTSeqID/32]+NCA_OFFSET_HDMA_PACKET-4,sizeof(U64));
				/* fill the right vaule of nca */
				tmp.ornament=PacketAddress+CONTROL_OFFSET_HDMA_PACKET;
				/* write back */
				PutToLocalMem(&tmp,currentINTSeqID/32, HDMAPacketQTail[currentINTSeqID/32]+NCA_OFFSET_HDMA_PACKET-4,sizeof(U64));
				/* get original npa value */
				GetFromLocalMem(&tmp, currentINTSeqID/32,HDMAPacketQTail[currentINTSeqID/32]+NPA_OFFSET_HDMA_PACKET, sizeof(U64));
				/* fill the right npa value */
				tmp.data=PacketAddress;
				/* write back */
				PutToLocalMem(&tmp, currentINTSeqID/32, HDMAPacketQTail[currentINTSeqID/32]+NPA_OFFSET_HDMA_PACKET, sizeof(U64));
				HDMAPacketQTail[currentINTSeqID/32]=PacketAddress;
			}		
			

			loffset=CurrentPacket->PacketHead.NPA;
			while(loffset!=U32NULL){
			    	CurrentPacket=&tmpPacket;
				GetFromLocalMem(&tmpPacket,currentINTSeqID/32,loffset,sizeof(SX4_HDMA_PACKET) );
				HDMAPacketQCount[currentINTSeqID/32]++;
				PacketAddress=CurrentPacket->PacketHead.Address;
				if (HDMAPacketQHead[currentINTSeqID/32]==U32NULL){
					HDMAPacketQHead[currentINTSeqID/32]=PacketAddress;
					HDMAPacketQTail[currentINTSeqID/32]=PacketAddress;
				}
				else{
					U64    tmp;
					/*get the original nca value */
					GetFromLocalMem(&tmp, currentINTSeqID/32,HDMAPacketQTail[currentINTSeqID/32]+NCA_OFFSET_HDMA_PACKET-4,sizeof(U64));
					/* fill the right vaule of nca */
					tmp.ornament=PacketAddress+CONTROL_OFFSET_HDMA_PACKET;
					/* write back */
					PutToLocalMem(&tmp,currentINTSeqID/32, HDMAPacketQTail[currentINTSeqID/32]+NCA_OFFSET_HDMA_PACKET-4,sizeof(U64));
					/* get original npa value */
					GetFromLocalMem(&tmp, currentINTSeqID/32,HDMAPacketQTail[currentINTSeqID/32]+NPA_OFFSET_HDMA_PACKET, sizeof(U64));
					/* fill the right npa value */
					tmp.data=PacketAddress;
					/* write back */
					PutToLocalMem(&tmp, currentINTSeqID/32, HDMAPacketQTail[currentINTSeqID/32]+NPA_OFFSET_HDMA_PACKET, sizeof(U64));
					HDMAPacketQTail[currentINTSeqID/32]=PacketAddress;
				}		
				loffset=CurrentPacket->PacketHead.NPA;
			}
			
		    	 if (loffset==U32NULL){
				U8	index;

				SXFreeSEQID(currentINTSeqID/32, currentINTSeqID%32);


				hdmaWaitingISR[currentINTSeqID/32]=0;
				HDMAModuleNeedPush[currentINTSeqID/32]=1;
				HDMAAdapterNeedPush[currentINTSeqID/32]=currentINTSeqID/32;
				HDMAModuleIDNeedPush[currentINTSeqID/32]=currentModuleID;

				if (HDMAModuleNeedPush[0]){
					StartHDMAOperation(HDMAAdapterNeedPush[0],HDMAModuleIDNeedPush[0]);
				}
				if (HDMAModuleNeedPush[1]){
					StartHDMAOperation(HDMAAdapterNeedPush[1],HDMAModuleIDNeedPush[1]);
				}
				/* xor push need here */
				for(index=0;index<MAX_ADAPTER_NUM;index++)
					if (XORModuleNeedPush[index])
						StartXOROperation(XORAdapterNeedPush[index]);
				/* ata push need here */
				if (ATAPushDirectionS2L){
					for(index=0;index<16;index++)
						if (ATAModuleNeedPush[index])
							StartATAOperation(ATAAdapterNeedPush[index],ATAModuleIDNeedPush[index]);
				}else{
					for(index=0;index<16;index++)
						if (ATAModuleNeedPush[15-index])
							StartATAOperation(ATAAdapterNeedPush[15-index],ATAModuleIDNeedPush[15-index]);
				}
				ATAPushDirectionS2L^=1;              
		    	 	break;
		    	 }		    	 

             /*
             ReadHDMAPort(ADAPTER_CONFIG_INFO.XORBaseAddress[currentAdapterID], \
                     0x10*currentModuleID+0x04, dTaskErrorStatus)    	

             switch (dTaskErrorStatus)
			 {
				case Soft ECC error:
                     ....
					 break;

				case HARD ECC Error:
					 ....	
					 break;

				case Drive Error:
					 ....
					 break;
				
				case Under Run Error:
   					 ....
					 break;	
				 
				case SG Abort:
					 ....
					 break;	
			}//end of switch
			*/
       	 }
	     else
    	 {
           //set status of dTask to successfull
    	 }

/*    	 if(ReadingReservedSector){
		bpREQ   p_rq;
		bpSEQ   p_sq;
    		bpDTASK pDtask;


	       
	      U32 statusDword = ScsiPortReadPortUlong( gAdapterConfigInfo.SEQBaseAddress[0]+ 31);

		pDtask = tmpTask;
              pDtask->bStatus =0x04;// BUSMASTER_STATUS_NOERROR;
		pDtask->ata_reg.cmd.bStatus =0x50;// IDE_STATUS_IDLE;
		ReadingReservedSector--;
		tmpReq->bCDB[0]=0xe0;
//		HDMAPacketQCount[currentAdapterID]=0;
		#ifdef _INVERT_
			ATAReturn(pDtask);
		#else
			ChannelReturn(pDtask);
		#endif

		if(ReadingReservedSector==0){
			
			buf_init((wFreeLocalPoolSize-0x200000)/10*9);

		}


 	 }	 else*/
 	 {


//modified by Jeff 2001/10/11 for debug problem
#ifdef NT_DBG
		if (((bpREQ)((PSX4_HDMA_PACKET)CurrentPacket)->PacketHead.PTA)->debugFlag==0xbb){
			bpREQ   p_rq;
			U8 i;
			
			DbgPrint("Break 24\n");
			PTIDbgBreakPoint();

			p_rq=((bpREQ)((PSX4_HDMA_PACKET)CurrentPacket)->PacketHead.PTA);
			i=1;
			i=2;
		}
#endif		
//		HDMAPacketQCount[currentAdapterID]=0;
		HDMAReturn((bpREQ)((PSX4_HDMA_PACKET)CurrentPacket)->PacketHead.PTA);
			
	 }


    	 /*------------------------------
    	 | free packet command memory
    	 ------------------------------*/
    	 SXFreePacket(currentINTSeqID/32, HDMA_PAC, loffset);

	 SXFreeSG(currentINTSeqID/32,tmpPacket.HDMAPacket.ulPSGHost);
	 SXFreeSG(currentINTSeqID/32,tmpPacket.HDMAPacket.ulPSGLocal);
	 
    	 /*------------------------------
    	 | delete timer
    	 ------------------------------*/
    	 /*
                 code ????
    	 */
    	 
		loffset=CurrentPacket->PacketHead.NPA;
    	 if (loffset==U32NULL){
		U8  index;
		
		SXFreeSEQID(currentINTSeqID/32,currentINTSeqID%32);

		
		hdmaWaitingISR[currentINTSeqID/32]=0;
		
		
		/* hdma push here */
		if (HDMAModuleNeedPush[0]){
			StartHDMAOperation(HDMAAdapterNeedPush[0],HDMAModuleIDNeedPush[0]);
		}
		if (HDMAModuleNeedPush[1]){
			StartHDMAOperation(HDMAAdapterNeedPush[1],HDMAModuleIDNeedPush[1]);
		}
		/* xor push  here */
		for(index=0;index<MAX_ADAPTER_NUM;index++)
			if (XORModuleNeedPush[index])
				StartXOROperation(XORAdapterNeedPush[index]);
		/* ata push  here */
		if (ATAPushDirectionS2L){
			for(index=0;index<16;index++)
				if (ATAModuleNeedPush[index])
					StartATAOperation(ATAAdapterNeedPush[index],ATAModuleIDNeedPush[index]);
		}else{
			for(index=0;index<16;index++)
				if (ATAModuleNeedPush[15-index])
					StartATAOperation(ATAAdapterNeedPush[15-index],ATAModuleIDNeedPush[15-index]);
		}
		ATAPushDirectionS2L^=1;
    	 	break;
    	 }
	    	CurrentPacket=&tmpPacket;
	       GetFromLocalMem(&tmpPacket,currentINTSeqID/32,loffset,sizeof(SX4_HDMA_PACKET) );
	}
}/* end of XOR*/
}
EnableInt();
return 1;

}



			
		

